/**
 * Project mosaic
 *
 * SimAboutDialog.java
 *
 * copyright 2000, JKU Linz, Austria
 */

package mosaic.sim.kernel;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// =================================================================================================
/**
* Dialog for the About information of the simulation application.
* Pops up with MenuItem About
* Shows general information about SimBeans.
*/
public class SimAboutDialog extends JDialog {

  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();

  
  public SimAboutDialog(SimMainFrame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
      getContentPane().add(panel1);
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace(frame.getSimApplication().getLogPrinter().getLogStream("error"));
    }
  }


  public SimAboutDialog(SimMainFrame frame) {
    this(frame, "", false);
  }


  public SimAboutDialog(SimMainFrame frame, boolean modal) {
    this(frame, "", modal);
  }


  public SimAboutDialog(SimMainFrame frame, String title) {
    this(frame, title, false);
  }

  void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

} // ===============================================================================================


