package mosaic.sim.kernel.continuous;

/**
* Diese Ausnahmebedingung zeigt an, da eine als Zustand definierte Variable keine
* Ableitung besitzt. Das bedeutet, da die Memberfunktion <code>setDerivative</code>
* der Klasse <code>Variable</code> fr die auslsende Variable aufgerufen werden
* mu.
*/

public class CSENoDerivative
   extends ContSimulationException
   {
   /**
   * Erzeugt eine Instanz dieser Klasse mit fixem Fehlertext.
   */
   public CSENoDerivative()
      { this("state has no derivative"); }

   /**
   * Erzeugt eine Instanz der Klasse mit bergebenem Fehlertext.
   * @param s Fehlertext der Ausnahmebedingung
   */
   public CSENoDerivative(String s)
      { super(s); }
   } // class CSENoDerivative

// end of CSENoDerivative.java