package mosaic.sim.kernel.continuous;

/**
* Diese Ausnahmebedinung zeigt an, da fr den, dem Modell zugewiesenen,
* Integrator keine mathematische Integrationsmethode bestimmt wurde. Es mu die
* Memberfunktion <code>setIntegrationMethod</code> der Klasse <code>Integrator</code>
* mit einer Implementierung des Interfaces <code>IntegrationMethod</code>
* aufgerufen werden.
*/

public class CSENoIntegrationMethod
   extends ContSimulationException
   {
   /**
   * Erzeugt eine Instanz dieser Klasse mit fixem Fehlertext.
   */
   public CSENoIntegrationMethod()
      { this("no integration method defined"); }

   /**
   * Erzeugt eine Instanz der Klasse mit bergebenem Fehlertext.
   * @param s Fehlertext der Ausnahmebedingung
   */
   public CSENoIntegrationMethod(String s)
      { super(s); }
   } // class CSENoIntegrationMethod

// end of CSENoIntegrationMethod.java
