package mosaic.sim.kernel.continuous;

import mosaic.sim.kernel.*;

/**
* Diese Klasse dient einerseits als Grundklasse fr smtliche Ausnahmen, die von
* dem <code>package sim.kernel.continuous</code> ausgelst werden. Es werden durch die
* Funktionen immer Objecte der Klasse <code>ContinuousSimulationExeption</code>
* ausgelst. Zur Laufzeit jedoch steckt hinter diesen eine Instanz der von dieser
* Klasse abgeleiteten Ausnahmebedingunen. Um diese gesondert abfangen zu knnen,
* mu der Laufzeittyp mit dem Operator <code>instanceOf</code> erfragt werden.
* Die Instanzen der abgeleiteten Klassen, welche ausgelst werden, stehen direkt
* bei der Beschreibung der einzelnen Funktion der Anwendungsklassen.
*/

public abstract class ContSimulationException
   extends SimException
   {
   /**
   * Erzeugt eine Instanz dieser Klasse mit fixem Fehlertext.
   */
   public ContSimulationException()
      { super("unknown continuous simulation exception"); }

   /**
   * Erzeugt eine Instanz der Klasse mit bergebenem Fehlertext.
   * @param s Fehlertext der Ausnahmebedingung
   */
   public ContSimulationException(String s)
      { super(s); }
   } // class ContSimulationException

// end of ContSimulationException.java
