package mosaic.sim.kernel.continuous;

import java.util.ArrayList;

/**
* Interface fr die mathematische Methode des Integrators. Jede numerische
* Integrationsmethode, die der Integrator verwenden soll, mu dieses Integerface
* untersttzen.
*/

public interface IntegrationMethod {
   /** 
   * Mu aufgerufen werden, wenn sich ein Modell ndert und somit die Struktur
   * der Modellvariablen.
   */
   public void initialize(ArrayList stateArrayList, ArrayList equationArrayList);

   /**
   * Fhrt die Geleichungen der einzelnen Untermodelle aus.
   */
   public void doEquations()
      throws ContSimulationException; 
   /**
   * Fhrt einen Integrationsschritt aus. Fr eine genaue Beschreibung des
   * Kommunkikatonsobjektes, das an diese Methode bergeben wird, siehe
   * zur Klasse Integrator.
   * @param stepWidth initiale Schrittweite fr den Integrationsschritt
   * @param data Modelldaten
   */
   public void integrationStep(double currTime, double StepWidth)
                  throws ContSimulationException;

   } // interface IntegrationMethod
  
// end of IntegrationMethod.java  
 