
//Titel:SimBeans 3.0
//Version:
//Copyright:Copyright (c) 1998
//Autor:hp
//Organisation:jku
//Beschreibung:Simulation kernel containing basic simulation
//functionality

package mosaic.sim.kernel.control;

import java.beans.*;

public class SimulatorBeanInfo extends SimpleBeanInfo {
  Class beanClass = Simulator.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  
  public SimulatorBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _projectSettings = new PropertyDescriptor("projectSettings", beanClass, "getProjectSettings", "setProjectSettings");
      _projectSettings.setDisplayName("projectSettings");
      _projectSettings.setShortDescription("projectSettings");
      
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
        _projectSettings,
      };
      return pds;
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
    }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
}

 