
/**
 * AlarmEventView.java
 *
 *
 * Created: Wed Nov 17 23:40:04 1999
 *
 * @author Reitinger Bernhard
 * @version 1.0
 */
package mosaic.sim.kernel.output;

import javax.swing.*;
import javax.swing.text.*;
import java.awt.Color;
import java.awt.Font;
import mosaic.sim.kernel.*;

public class AlarmEventView extends JTextPane implements AlarmEventListener {
    
    final static Color darkgreen = new Color(25,124,22);
    
    public AlarmEventView() {
	    setEditable(false);
	    Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);
 
	    Style regular = addStyle("regular", def);
        StyleConstants.setFontFamily(def, "SansSerif");

        Style s = addStyle("size", regular);
        StyleConstants.setFontSize(s, 12);

        Style green = addStyle("green", s);
        StyleConstants.setForeground(green, darkgreen);

        Style red = addStyle("red", s);
        StyleConstants.setForeground(red, Color.red);
	
	    s = addStyle("ray", regular);
        StyleConstants.setIcon(s, mosaic.util.img.Img.createSimImageIcon("ray.gif"));

	    s = addStyle("ok", regular);
        StyleConstants.setIcon(s, mosaic.util.img.Img.createSimImageIcon("ray.gif"));
    }
    public void alarmSet(AlarmEvent e) {
	    Document doc = getDocument();
        try {
	        doc.insertString(doc.getLength(), " ", getStyle("ray"));
	        doc.insertString(doc.getLength(), " "+e.getMessage()+"\n", getStyle("red"));
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text.");
        }
    }

    public void alarmReset(AlarmEvent e) {
	    Document doc = getDocument();
        try {
	        doc.insertString(doc.getLength(), " ", getStyle("ok"));
	        doc.insertString(doc.getLength(), " "+e.getMessage()+"\n", getStyle("green"));
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text.");
        }
    }

    public static void main(String[] args) {
	    final JFrame f = new JFrame();
	    final AlarmEventView a = new AlarmEventView();
	    Thread t = new Thread() {
		    public void run() {
                try {
                a.alarmSet(new AlarmEvent(f, "testing", false));
                sleep(1000);
                a.alarmReset(new AlarmEvent(f, "testing reset", false));
                sleep(1000);
                a.alarmSet(new AlarmEvent(f, "testing", false));
                sleep(1000);
                a.alarmReset(new AlarmEvent(f, "testing reset", false));
                sleep(1000);
                a.alarmReset(new AlarmEvent(f, "testing reset", false));
                sleep(1000);
                a.alarmReset(new AlarmEvent(f, "testing reset", false));
                sleep(1000);
                a.alarmSet(new AlarmEvent(f, "testing", false));
                sleep(1000);
                a.alarmReset(new AlarmEvent(f, "testing reset", false));
                } catch (Exception e) {}
                }
            };
        f.getContentPane().add(a);
        f.setBounds(100,100,300,300);
        f.show();
        t.start();
    }
} // AlarmEventView
