
//Titel:sim Beans 0.3
//Version:
//Copyright:Copyright (c) 1998
//Autor:Herbert Praehofer
//Organisation:
//Beschreibung:Basic output and animation for simulation

package mosaic.sim.kernel.output;

import java.beans.*;

public class CollectionPaintViewBeanInfo extends SimpleBeanInfo {
  Class beanClass = CollectionPaintViewBeanInfo.class;
  String iconColor16x16Filename = "ComponentArrayListPaintViewC16.gif";
  String iconColor32x32Filename = "ComponentArrayListPaintViewC32.gif";
  String iconMono16x16Filename = "ComponentArrayListPaintViewC16.gif";
  String iconMono32x32Filename = "ComponentArrayListPaintViewC32.gif";

  
  public CollectionPaintViewBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _alignment = new PropertyDescriptor("alignment", beanClass, "getAlignment", "setAlignment");
      
      PropertyDescriptor _ascending = new PropertyDescriptor("ascending", beanClass, "isAscending", "setAscending");
      
      PropertyDescriptor _descending = new PropertyDescriptor("descending", beanClass, "isDescending", "setDescending");
      
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
        _alignment,
        _ascending,
        _descending,
      };
      return pds;
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
    }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
}

 