package mosaic.sim.kernel.output;

import javax.swing.*;
import java.awt.*;
public class HelpFrame extends JWindow {
    protected JTextArea helpText = new JTextArea("Here helpText comes up");

    public static int HELP_WINDOW_WIDTH = 200;


    public HelpFrame() {
        try  {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        helpText.setLineWrap(true);
        helpText.setColumns(20);
        helpText.setWrapStyleWord(true);
        helpText.setBackground(new java.awt.Color(255, 255, 200));
        helpText.setBorder(BorderFactory.createEtchedBorder());
        helpText.setText("Here helpText comes up.");
        helpText.setEditable(false);
        helpText.setFont(new java.awt.Font("Dialog", 0, 12));
        this.getContentPane().add(helpText, BorderLayout.CENTER);

    }

    public void setHelpText(String text) {
        if (text != null)  {
            helpText.setText(text);
            FontMetrics fm = helpText.getFontMetrics(helpText.getFont());
            int textWidth = fm.stringWidth(text);
            // use HELP_WINDOW_WIDTH pixels width
            int textHeight = (5 + (textWidth / HELP_WINDOW_WIDTH))* fm.getMaxAscent();
            this.setSize(HELP_WINDOW_WIDTH, textHeight);
        }
    }
}