
/**
 * OnOffAlarm.java
 *
 *
 * Created: Wed Nov 24 18:52:43 1999
 *
 * @author Reitinger Bernhard
 * @version
 */
package mosaic.sim.kernel.output;

import mosaic.sim.kernel.*;
import mosaic.sim.kernel.variable.*;

public class OnOffAlarm extends VariableChangeListenerAlarm  {
    
    private boolean alarmOnIncrease;
    private boolean alarmEnabled = false;
    
    public OnOffAlarm() {
	
    }

    public boolean testCondition(VariableChangeEvent e) {
        boolean value;

	if (e.getVariable().getValueObject() instanceof Boolean)
	    value = ((Boolean)((VariableChangeComponent)e.getVariable()).getValueObject()).booleanValue();
	else
	    return false;

	if (alarmOnIncrease) {
	    if (value && !alarmEnabled)  {
		alarmEnabled = true;
	    } else if (value) {
		alarmEnabled = false;
		return true;
	    }
	} else {                 // alarm on decrease
	    if (!value && !alarmEnabled)  {
		alarmEnabled = true;
	    } else if (!value) {
		alarmEnabled = false;
		return true;
	    }
	}
	return false;
    }
    

    /**
       * Get the value of alarmOnIncrease.
       * @return Value of alarmOnIncrease.
       */
    public boolean getAlarmOnIncrease() {return alarmOnIncrease;}
    
    /**
       * Set the value of alarmOnIncrease.
       * @param v  Value to assign to alarmOnIncrease.
       */
    public void setAlarmOnIncrease(boolean  v) {this.alarmOnIncrease = v;}
    
    
} // ThresholdAlarm
