
//Project:      SimBeans kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// class RandomDistribution         --------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// programmed by: hp
// last modified by: hp, 29.12.98
// documented by: hp, 29.12.98

package mosaic.sim.kernel.random;

import java.util.Random;
import java.awt.Graphics;

/** 
* Base class for all random distribtions.
* Extends java.util.Random which realizes a random seed.
* Implements Distribution and TimeSeed 
* @see java.util.Random 
*/
public class RandomDistribution extends BasicRandomComponent
                                implements Distribution, TimeSeed  {


    public void reset () {
      super.reset();
      // FOR LATER USE: randomSeed.setSeed(xxx);  //find random seed.
    }

   protected java.util.Random randomSeed = new java.util.Random();

   /** Gets the next random integer from java.util.Random.
   * Returns the next pseudorandom, uniformly distributed int value
   * from this random number generator's sequence.
   */
   public int getRandInt() {
        return ((int)Math.round(randomSeed.nextDouble()));
  }

  /** Gets the next random double from java.util.Random.
  * Returns the next pseudorandom, uniformly distributed double value
  * between 0.0 and 1.0 from this random number generator's sequence.
  */
  public double getRandDouble() {
        return (randomSeed.nextDouble());
  }

  /** Gets next time span (to the next event by calling getRandDouble*/
  public double getTimeSpan() {
      return getRandDouble();
  }
  
}
