package mosaic.sim.kernel.simevent;

import mosaic.sim.kernel.control.*;
import mosaic.sim.kernel.*;
import java.util.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.*;
import javax.swing.*;

public class BasicUserEventComponent extends AbstractModelComponent
implements mosaic.sim.kernel.simevent.UserEventComponent {

  /** contains all UserEventListeners */
  protected ArrayList listeners = new ArrayList();


  public BasicUserEventComponent() {
  }

// getValue --------------------------------------------------------------------
  /**
  * Gets the last from user entered value
  */
  public Double getValue() {
    return new Double(0.0); // change to value from GlgDoubleInput
  }

// tL --------------------------------------------------------------------------

   /**
   * Gets the time of last event
   */
   public double getTL()
      { return 0.0; }

   /**
   * Sets the time of last event
   */
   public void setTL(double newTime)
      { ; }


// -----------------------------------------------------------------------------
// interface userEventComponent ---------------------------------------------------
// -----------------------------------------------------------------------------

   /**
   * Add SimEventListener
   */
   public void addSimEventListener(SimEventListener simEventListener) {
      if (!listeners.contains(simEventListener))
         listeners.add(simEventListener);
      }

	 /**
   * Remove SimEventListener
   */
   public void removeSimEventListener(SimEventListener simEventListener) {
      if (listeners.contains(simEventListener))
         listeners.remove(simEventListener);
      }

   /**
   * Add InputEventListener
   */
   public void addUserEventListener(mosaic.sim.kernel.simevent.UserEventListener userEventListener) {
     if (!listeners.contains(userEventListener))
         listeners.add(userEventListener);
   }

   public Object getUserInput()
   { return getValue();
   }

	 /**
   * Remove InputEventListener
   */
   public void removeUserEventListener(mosaic.sim.kernel.simevent.UserEventListener userEventListener) {
      if (listeners.contains(userEventListener))
         listeners.remove(userEventListener);
      }

// event -----------------------------------------------------------------------
   /**
   * Trigger an event
   */
     public void triggerEvent() {
      UserEvent userEvent = new UserEvent(this);

      for(int loop=0;loop<listeners.size();loop++)
         ((SimEventListener)listeners.get(loop)).processSimEvent(userEvent);
	    }

// -----------------------------------------------------------------------------
// interface Comparable --------------------------------------------------------
// -----------------------------------------------------------------------------

// select order  ---------------------------------------------------------------

  /** variable to hold the selectOrder for the timer which is used as a priority
  * for tie breaking between several timer with equal next event time.
  */
  protected int selectOrder = 0;

  /** Gets the select order of the timer */
  public int getSelectOrder() {
      return selectOrder;
  }

  /** Sets the select order of the timer */
  public void setSelectOrder(int newOrder) {
    int oldSelectOrder = selectOrder;
    selectOrder= newOrder;
  }


} 