/**
 * Project mosaic
 *
 * ChangeRegistry.java
 *
 * copyright 2000, JKU Linz, Austria
 */

package mosaic.sim.kernel.variable;

import mosaic.sim.kernel.ModelComponent;
/**
* Basic class for registration of change events (VariableChange or PropertyChange).
* Used for  asynchronous change event handling by the simulator. 
* For change event a registry object is created and queued gobally in the simulator.
* The registries are handled in fifo manner by the simulator by method fireChangeEvent.
*/

abstract public class ChangeRegistry extends Object {
    
    /** variable to hold the source of the change event */
    ModelComponent source;

    /** Constructor for the ChangeRegistry initializing source. */
    public ChangeRegistry (ModelComponent s) {
        source = s;
    }

    /** Fires a change event */ 
    abstract public void fireChangeEvent ();
    
}  // end ChangeRegistry ---------------------------------------------------------------------------

