
//Project:      mosaic kernel
//Version:      0.3
//Copyright:    Copyright (c) 1998
//Author:       Herbert Praehofer, Johannes Sametinger, Alois Stritzinger
//Affiliation:  Johannes Kepler University, Linz, Austria

// -----------------------------------------------------------------------------------------------------------
// interface ValueFilter    ----------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// programmed by: hp
// last modified by: hp, 14.12.98
// documented by: hp, 14.12.98


package mosaic.sim.kernel.variable;

import mosaic.sim.kernel.*;

/**
* Interface for strategy objects to filter values for output.
* Used by BasicVariableObserver.
* <p>
* Specifies one method to test a value of type Object, 
* and one method to filter a value of type Object.
*
* @see <{mosaic.sim.kernel.variable.BasicVariableObserver}>
*/
public interface ValueFilter {

// testValue ---------------------------------------------------------------------------------------------

  /** Method to test a value if it is valid.*/
  public boolean testValue (Object value);

// testValue ---------------------------------------------------------------------------------------------

  /** Method to filter a value if it is valid.*/
  public Object filterValue (Object value);

}
