/*****************************************************************************
 *  Project: DEVSNeuron
 *  Description: discrete event-based simulation of spiking neural networks
 *  Filename: $RCSfile: BasicTest1.java,v $
 *  Author: Rene Mayrhofer
 *  Copyright: Rene Mayrhofer 2001
 *  Project version tag: $Name:  $
 *  File version: $Revision: 1.4 $
 *  Last changed at: $Date: 2002/02/20 00:36:06 $
 *  Last changed by: $Author: Rene $
 *****************************************************************************/

package mosaic.sim.neuron.examples;

import mosaic.sim.*;
import mosaic.sim.kernel.*;
import mosaic.sim.neuron.*;
import mosaic.sim.neuron.netinputs.*;
import java.awt.*;

public class BasicTest1 extends SimApplication {

	public BasicTest1() {
		SimpleMainFrame frame = new SimpleMainFrame(this);

// ========> create your panel here <==========================================//
		BasicTest1Panel p=new BasicTest1Panel();
		frame.setModelPanel(p);
// ============================================================================//

		frame.pack();
		frame.setVisible(true);
		reset();
	}

	public static void main(String[] args) {
		BasicTest1 basicTest11 = new BasicTest1();
	}
}


class BasicTest1Panel extends ModelPanel {
	RandomSpikeSource s1 = new RandomSpikeSource(10);
	RandomSpikeSource s2 = new RandomSpikeSource(10);
	Neuron n1 = new Neuron();
	Neuron n2 = new Neuron();

	public BasicTest1Panel() {
		try {
			jbInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	private void jbInit() throws Exception {
		/*ConstantPLSynapse master = new ConstantPLSynapse(null, null, 1, 0);
		n1.setMasterSynapse(master);*/
		n1.setLabel("n1");
		n1.setLayout(null);
		//n2.setMasterSynapse(master);
		n2.setLabel("n2");
		n2.setLayout(null);
		s1.setLabel("s1");
		s1.setLayout(null);
		s2.setLabel("s2");
		s2.setLayout(null);
		this.setLayout(null);
		this.add(n1, null);
		this.add(n2, null);
		this.add(s1, null);
		this.add(s2, null);
		s1.init();
		s2.init();

		PLPotential p1 = new PLPotential(50);
		n1.setPotential(p1);
		PLPotential p2 = new PLPotential(50);
		n2.setPotential(p2);

		ConstantPLThreshold threshold = new ConstantPLThreshold();
		n1.setThreshold(threshold);
		n2.setThreshold(threshold);
		ConstantPLThreshold.setAbsoluteRefractionTime(3);
		ConstantPLThreshold.setQuiescentValue(5);
		ConstantPLThreshold.setRelativeRefractionStartValue(5);
		ConstantPLThreshold.calculateRelativeRefractionTime();

		/*n1.addInput(s1);
		n1.addInput(s2);
		n2.addInput(s1);
		n2.addInput(s2);*/

		ConstantPLSynapse sy1 = new ConstantPLSynapse(s1, n1, 1, 0);
		sy1.setLabel("sy1");
		ConstantPLSynapse sy2 = new ConstantPLSynapse(s1, n2, 1, 0);
		sy2.setLabel("sy2");
		ConstantPLSynapse sy3 = new ConstantPLSynapse(s2, n1, 1, 0);
		sy3.setLabel("sy3");
		ConstantPLSynapse sy4 = new ConstantPLSynapse(s2, n2, 1, 0);
		sy4.setLabel("sy4");

		PLFunction synapseResponse = new PLFunction(3);
		synapseResponse.gradients[0] = 1;
		synapseResponse.gradientTimes[0] = 0;
		synapseResponse.gradients[1] = -1;
		synapseResponse.gradientTimes[1] = 3;
		synapseResponse.gradients[2] = 0;
		synapseResponse.gradientTimes[2] = synapseResponse.getEndTime(0, 2);
		System.out.println("Synapse response function set to:");
		System.out.print(synapseResponse.toString());
		ConstantPLSynapse.setResponse(synapseResponse);
	}
}
