/*****************************************************************************
 *  Project: DEVSNeuron
 *  Description: discrete event-based simulation of spiking neural networks
 *  Filename: $RCSfile: SpikeViewTest1.java,v $
 *  Author: Rene Mayrhofer
 *  Copyright: Rene Mayrhofer 2001
 *  Project version tag: $Name:  $
 *  File version: $Revision: 1.2 $
 *  Last changed at: $Date: 2001/09/28 10:23:56 $
 *  Last changed by: $Author: Rene $
 *****************************************************************************/

package mosaic.sim.neuron.examples;

import mosaic.sim.*;
import mosaic.sim.kernel.*;
import mosaic.sim.neuron.*;
import mosaic.sim.neuron.netinputs.*;
import mosaic.sim.neuron.visualisation.*;
import java.awt.*;
import javax.swing.*;

public class SpikeViewTest1 extends SimApplication {

	public SpikeViewTest1() {
		SimpleMainFrame frame = new SimpleMainFrame(this);

// ========> create your panel here <==========================================//
		SpikeViewTest1Panel p=new SpikeViewTest1Panel();
		frame.setModelPanel(p);
// ============================================================================//

		frame.pack();
		frame.setVisible(true);
		reset();
	}

	public static void main(String[] args) {
		SpikeViewTest1 spikeViewTest11 = new SpikeViewTest1();
	}

}

class SpikeViewTest1Panel extends ModelPanel {
	RandomSpikeSource s1 = new RandomSpikeSource(10);
	RandomSpikeSource s2 = new RandomSpikeSource(10);
	ViewSynchronizer sync = new ViewSynchronizer();
	SpikeView v1 = new SpikeView("s1");
	SpikeView v2 = new SpikeView("s2");

	public SpikeViewTest1Panel() {
		try {
			jbInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	private void jbInit() throws Exception {
		s1.setLabel("s1");
		s1.setLayout(null);
		s2.setLabel("s2");
		s2.setLayout(null);
		v1.setName("v1");
		v2.setName("v2");
		v1.setTMax(50);
		v2.setTMax(50);
		sync.addView(v1);
		sync.addView(v2);
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.add(s1);
		this.add(s2);
		this.add(v1);
		this.add(v2);

		s1.addOutput(v1);
		s2.addOutput(v2);
	}
}
