/*****************************************************************************
 *  Project: DEVSNeuron
 *  Description: discrete event-based simulation of spiking neural networks
 *  Filename: $RCSfile: ImageConverterTest.java,v $
 *  Author: Rene Mayrhofer
 *  Copyright: Rene Mayrhofer 2001
 *  Project version tag: $Name:  $
 *  File version: $Revision: 1.2 $
 *  Last changed at: $Date: 2002/05/14 12:20:13 $
 *  Last changed by: $Author: rene $
 *****************************************************************************/

package mosaic.sim.neuron.tests;

import java.awt.image.*;
import junit.framework.*;
import mosaic.sim.neuron.*;
import mosaic.sim.neuron.netinputs.*;
import mosaic.sim.neuron.netoutputs.*;

public class ImageConverterTest extends TestCase {
	private ImageInput in1;
	private ImageOutput out1;
	private ImageInput in2;
	private ImageOutput out2;

	protected void setUp() {
		try {
			// create the converters
			in1 = new ImageInput("mosaic/sim/neuron/tests/lena_bw.gif", 1);
			in2 = new ImageInput("mosaic/sim/neuron/tests/lena_bw.gif", 2);
			out1 = new ImageOutput("lena-new1.png", "png", in1.getWidth(), in1.getColorModel(), in1.getSampleModel());
			out2 = new ImageOutput("lena-new2.png", "png", 0, in2.getColorModel(), in2.getSampleModel());
		}
		catch (Exception e) {
			e.printStackTrace();
			assertTrue(false);
		}
	}

	protected void tearDown() {
		// currently nothing to do
	}

	public ImageConverterTest(String name) {
		super(name);
	}

	public void testOneDim() {
		try {
			in1.setCoder(new VectorInputCoder() {
				public void enterVector(double[] vector) {
					try {
						out1.outputEvent(vector);
					}
					catch (Exception e) {
						e.printStackTrace();
						assertTrue(false);
					}
				}

				public NeuronOutput getOutput(int i) {return null;}
			} );
			in1.startInput();
		}
		catch (Exception e) {
			e.printStackTrace();
			assertTrue(false);
		}
	}

	public void testTwoDim() {
		try {
		   in2.setCoder(new MatrixInputCoder() {
			   public void enterMatrix(double[][] matrix) {
				   try {
						out2.outputEvent(matrix);
					}
					catch (Exception e) {
						e.printStackTrace();
						assertTrue(false);
					}
				}

				public NeuronOutput getOutput(int i, int j) {return null;}
			} );
			in2.startInput();
		}
		catch (Exception e) {
			e.printStackTrace();
			assertTrue(false);
		}
	}
}
