package mosaic.util.custom;

import java.beans.*;

/**
 * Simple Editor for Boolean Objects using tags.
 *
 * @version 17 Feb 1999
 * @author Thomas Hilpold
 */
public class BooleanEditor extends PropertyEditorSupport {

    public BooleanEditor() {
    }

    public String getAsText () {
        if (getValue().equals(Boolean.TRUE)) return "true";
        else return "false";
     }

    public Object getValue() {
        Object val;
        if (super.getValue() == null) setValue(Boolean.FALSE);
        return super.getValue();
    }

    public void setAsText(String text)
            throws java.lang.IllegalArgumentException
    {
        if (text.equals ("true")) setValue (Boolean.TRUE);
        else if (text.equals ("false")) setValue (Boolean.FALSE);
        else throw (new IllegalArgumentException());
        OutFrame.out("SetAsTExt "+ this);
    }

    public String[] getTags () {
        return new String[] { "true", "false" };
    }

    public String getJavaInitializationString()
    {
        if (getValue().equals(Boolean.TRUE)) return "Boolean.TRUE";
        else return "Boolean.FALSE";
    }

   public boolean supportsCustomEditor()
    {
        return false;
    }

    public java.awt.Component getCustomEditor()
    {
        return null;
    }
}
