package mosaic.util.custom;

import java.beans.PropertyEditor;

/**
 * Interface extending PropertyEditor to support the PropertyCustomEditor
 * with tags to show for selecting a subclass of the property.
 * <p>
 * Intended to show a customEditor of a PropertyEditor
 *
 * An older version of PropertyCustomEditor just used getTags of PropertyEditor,
 * but Jbuilder2 could not cope with getTags() != null and supportsCustomEd
 * == true.
 *
 * @version 17 Jan 1999
 * @author Thomas Hilpold
 * @see PropertyCustomEditor
 * @see GenericBeanEditor
 */
public interface CustomTagsPropertyEditor extends PropertyEditor {

    /**
     * Declare, if You want to use a choice where the user can
     * select a subClass.
     */
    public boolean supportsCustomTags();

    /**
     * Should return the fully qualified classnames if supportsCustomTags()
     * is true.
     */
    public String[] getCustomTags();
}
