package mosaic.util.custom;

import java.awt.*;
import java.lang.reflect.Array;
import javax.swing.UIManager;

/**
 * The Editortester.class is for testing PropertyEditor Classes. For most
 * Methods, a Button exists which reacts on pressure thru calling the
 * approriate Methods of the PropertyEditor Class. Watch the exceptions
 * thrown in the log box! (On Windows Systems Dos Box)
 * tags are supported, customTags as used in some sim-Editors are not
 * <p>
 * Usage:
 *  1. Enter a classname into the combobox or select a predefined from it.
 *     (Primitive types are supported, just add an asterisk before
 *      the typename of the Primitive (see combobox items))
 *  2. Select the Array checkbox if You want an Array of the given type and
 *      the ArrayEditor
 *  3. Push buttons or enter text first in the appropriate fields.
 *  4. getInit shows up the initialization String used by various
 *     RAD-Environments to generate Code for customization.
 *
 * <p>
 * See EditorTester Class for Documentation
 * <p>
 * @see sim.custom.EditorTesterFrame
 * @version 02 Jan 1999
 * @author Thomas Hilpold
 */
public class EditorTester {
    boolean packFrame = false;

    //Anwendung konstruieren

    public EditorTester() {
        EditorTestFrame frame = new EditorTestFrame();
        frame.setNewClassDefaults(defaultClassStrings);
        //Frames validieren, die eine voreingestellte Gre besitzen
        //Frames packen, die ntzliche bevorzugte Infos ber die Gre besitzen, z.B. aus ihrem Layout
        if (packFrame)
            frame.pack();
        else
            frame.validate();
        //Fenster zentrieren
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height)
            frameSize.height = screenSize.height;
        if (frameSize.width > screenSize.width)
            frameSize.width = screenSize.width;
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    /** extend this definition to have more predefined classes */
    String[] defaultClassStrings = new String[] {
        "*bool",
        "*byte",
        "java.awt.Color",
        "*double",
        "*float",
        "java.awt.Font",
        "*int",
        "*long",
        "sim.util.Distribution",
        };

    //Main-Methode
    public static void main(String[] args) {
        try  {
            //UIManager.setLookAndFeel(new javax.swing.plaf.windows.WindowsLookAndFeel());
            //UIManager.setLookAndFeel(new javax.swing.plaf.motif.MotifLookAndFeel());
            UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
        }
        catch (Exception e) {
        }
        new EditorTester();
    }
}

