package mosaic.util.custom;

import java.awt.*;
import java.beans.*;
import java.util.Vector;

/**
 * Simple Propertyeditor for Arrays of Integers using setAsText.
 * Format used: {1,2,3,4,5,7}
 *
 * @author Thomas Hilpold
 * @version 12 Jan 1999
 */
public class IntegerArrayEditor extends java.beans.PropertyEditorSupport {

    public String getAsText () {
        Integer[] val = (Integer[])getValue();
        String ret = new String ("{");
        for (int i = 0; i < val.length - 1; i++) {
            ret = ret + val[i].toString() + ",";
        }
        ret = ret + val[val.length -1].toString() + "}";
        return ret; //"{1,3,4324,324}"
    }

    public Object getValue() {
        Object val;
        if (super.getValue() == null) {
            val = new Integer[]{new Integer(1), new Integer(2), new Integer(46543)};
            setValue(val);
        }
        return super.getValue();
    }

    public void setAsText(String text)
            throws java.lang.IllegalArgumentException {
        Vector vals = new Vector();
        Integer[] newArray;
        Integer cur;
        boolean error = false;
        int indexA;
        int indexB;
        indexA = text.indexOf('{'); //A{A334,5}
        indexB = indexA;
        try {
            while ((indexA != -1) && (indexB != -1)) {
                indexA++;   //{A3A,5}
                indexB = text.indexOf(',', indexA); //{A3A34B,B5}
                //for the last integer
                if (indexB == -1) {
                    indexB = text.indexOf('}', indexA);
                }
                if (indexB != -1) {
                    cur = Integer.valueOf(text.substring(indexA,indexB )); //334
                    vals.addElement(cur);
                }
                indexA = indexB;
            }
        }catch (Exception e) {System.out.println(e.toString());error = true;};
        if (!error) {
            newArray = new Integer[vals.size()];
            for (int i = 0; i < newArray.length; i++) {
                newArray[i] = (Integer)vals.elementAt(i);
            }
            setValue(newArray);
        }
        // else throw (new IllegalArgumentException());
    }

    public String[] getTags() {
        return null;
    }

    /**
     * Should return an anonymously created Array of Integers
     * Syntax:
     * new Integer[]{new Integer(3) , ...};
     */
    public String getJavaInitializationString() {
      return (new InitStringCreator().getInitStringForArray(getValue()));
    }
    /** There is no visual Editor */
    public boolean supportsCustomEditor() {
        return false;
    }

    public java.awt.Component getCustomEditor() {
        return null;
    }
}
