package mosaic.util.custom;

import javax.swing.*;
import java.awt.*;

/**
 * Provides a Frame to send error output to or routes the output
 * to System.err. Simply call static method out(String).
 * Frame becomes visible on first call of method out.
 *
 * @author Thomas Hilpold
 * @version 09 Jan 1999
 */
public class OutFrame extends Object {

    //
    // set toSyserr True if you dot like a frame
    // everything will be sent to System.err
    //

    /**
     * toggles if output is sent to System.err or
     * to a Frame.
     */
    private static boolean toSysErr = true;

    public static void createFrame() {
        count = 0;
        myFrame = new JFrame("OutFrame");
        myFrame.getContentPane().setLayout(new BorderLayout());
        myTextArea = new List();
        myFrame.getContentPane().add(myTextArea);
        myFrame.setSize(600,400);
        myFrame.setVisible(true);
    }

    /** prints a message to a Frame or System.err */
    public static void out(String what) {
        if (toSysErr) System.err.println("" + count +"  "+ what);
        else {
            if (myFrame == null) createFrame();
            myTextArea.add(" " + count + " - " + what);
            myTextArea.makeVisible(myTextArea.getRows() -1);
            myTextArea.select(myTextArea.getRows() -1);
        }
        count ++;
    }

    /** closes Frame */
    public static void close() {
        if (myFrame != null) {
            myFrame.setVisible(false);
            myFrame = null;
        }
    }

    private static List myTextArea;
    private static JFrame myFrame;
    private static int count;
}
