
//Title:        Ihr Produktname
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       H. Praehofer
//Company:      Johannes Kepler University Linz
//Description:  Ihre Beschreibung

package mosaic.vis.input;

import java.beans.*;

public class DualInputViewBeanInfo extends SimpleBeanInfo {
    Class beanClass = DualInputView.class;
    String iconColor16x16Filename;
    String iconColor32x32Filename;
    String iconMono16x16Filename;
    String iconMono32x32Filename;

    public DualInputViewBeanInfo() {
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        try  {
            PropertyDescriptor _expanded = new PropertyDescriptor("expanded", beanClass, "isExpanded", null);
            PropertyDescriptor _expandedSize = new PropertyDescriptor("expandedSize", beanClass, "getExpandedSize", "setExpandedSize");
            PropertyDescriptor _initValue = new PropertyDescriptor("initValue", beanClass, "getInitValue", "setInitValue");
            PropertyDescriptor _majorTickSpacing = new PropertyDescriptor("majorTickSpacing", beanClass, "getMajorTickSpacing", "setMajorTickSpacing");
            PropertyDescriptor _max = new PropertyDescriptor("max", beanClass, "getMax", "setMax");
            PropertyDescriptor _min = new PropertyDescriptor("min", beanClass, "getMin", "setMin");
            PropertyDescriptor _minorTickSpacing = new PropertyDescriptor("minorTickSpacing", beanClass, "getMinorTickSpacing", "setMinorTickSpacing");
            PropertyDescriptor _observedVariable = new PropertyDescriptor("observedVariable", beanClass, null, "setObservedVariable");
            PropertyDescriptor _paintTicks = new PropertyDescriptor("paintTicks", beanClass, "getPaintTicks", "setPaintTicks");
            PropertyDescriptor _userEventListener = new PropertyDescriptor("userEventListener", beanClass, "getUserEventListener", "setUserEventListener");
            PropertyDescriptor[] pds = new PropertyDescriptor[] {
	            _expanded,
	            _expandedSize,
	            _initValue,
	            _majorTickSpacing,
	            _max,
	            _min,
	            _minorTickSpacing,
	            _observedVariable,
	            _paintTicks,
	            _userEventListener,};
            return pds;










        }
        catch(IntrospectionException ex) {
            ex.printStackTrace();
            return null;
        }
    }

    public java.awt.Image getIcon(int iconKind) {
        switch (iconKind) {
	        case BeanInfo.ICON_COLOR_16x16:
	          return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
	        case BeanInfo.ICON_COLOR_32x32:
	          return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
	        case BeanInfo.ICON_MONO_16x16:
	          return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
	        case BeanInfo.ICON_MONO_32x32:
	          return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
	    }
        return null;
    }

    public BeanInfo[] getAdditionalBeanInfo() {
        Class superclass = beanClass.getSuperclass();
        try  {
            BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
            return new BeanInfo[] { superBeanInfo };
        }
        catch(IntrospectionException ex) {
            ex.printStackTrace();
            return null;
        }
    }
}
 
