
/**
 * SliderCondInputUI.java
 *
 *
 * Created: Thu Mar  9 09:54:18 2000
 *
 * @author Reitinger Bernhard
 * @version
 */
package mosaic.vis.input.ui;

import javax.swing.plaf.metal.MetalSliderUI;
import javax.swing.JSlider;
import java.awt.*;
import mosaic.vis.input.SliderCondInputView;

public class SliderCondInputUI extends MetalSliderUI {

    private JSlider comp = null;
    private SliderCondInputView parent = null;
    private String valueStr;
    private int precision = 2;
    private Rectangle rect = null;
    private String fillUpStr = "00000";   // dummy-string for fill up float

    public SliderCondInputUI() {
	super();
    }
    public SliderCondInputUI(JSlider b, SliderCondInputView par) {
	this(b);
	parent = par;
    }

    public SliderCondInputUI(JSlider b) {
	comp = b;
	valueStr = new String().valueOf((double)((comp.getMaximum()/2.0)/Math.pow((double)10,(double)precision)));

	comp.addChangeListener(new javax.swing.event.ChangeListener() {		 
		public void stateChanged(javax.swing.event.ChangeEvent e) {
		    int fill;
		    valueStr = new String().valueOf((double)(((JSlider)e.getSource()).getValue()/Math.pow((double)10,(double)precision)));
		    // fehlende nullen auffllen
		    if ((fill = valueStr.indexOf('.') - ((valueStr.length()-1-precision))) != 0) {
			valueStr += fillUpStr.substring(0,fill);
		    }
		    if (rect != null)
			comp.repaint(rect);
		    
		 }
	    });
	 
     }

    public void paintThumb(Graphics g) {
 	super.paintThumb(g);
	int width = comp.getSize().width;
	int height = comp.getSize().height;
	g.setColor(Color.black);
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	FontMetrics fm = g.getFontMetrics();
 	g.drawString(valueStr, width / 2 - fm.stringWidth(valueStr) / 2,
				 fm.getMaxAscent() +height/2);
	// repaint the minimum, just a small rectangle !
	if (parent != null) {
	    if ((rect == null) || parent.isResized()) {
		parent.setResized(false);
// 		System.out.println("width "+width);
		int drawWidth = comp.getMaximum();
		rect = new Rectangle(width/2-fm.stringWidth(new String().valueOf(drawWidth))/2, height/2-fm.getMaxAscent(),width,fm.getMaxAscent()*2);
	    }
	}
    }

    public void setPrecision(int val) {
	int fill;

	precision = val;
	valueStr = new String().valueOf((double)((comp.getMaximum()/2.0)/Math.pow((double)10,(double)precision)));
	if ((fill = valueStr.indexOf('.') - ((valueStr.length()-1-precision))) != 0) {
	    valueStr += fillUpStr.substring(0,fill);
	}
	comp.setValue((int)((parent.getMaximum()/2)*Math.pow((double)10,(double)precision)));
	System.out.println(comp.getValue());
    }

    public int getPrecision() {
	return precision;
    }

    public String getValueStr() {
	return valueStr;
    }


} // SliderCondInputUI
