/**
 * SliderInputUI.java
 *
 *
 * Created: Thu Mar  9 09:54:18 2000
 *
 * @author Reitinger Bernhard
 * @version
 */
package mosaic.vis.input.ui;

import javax.swing.plaf.metal.MetalSliderUI;
import javax.swing.JSlider;
import java.awt.*;
import mosaic.vis.input.SliderInputView;

public class SliderInputUI extends MetalSliderUI {

    private JSlider comp = null;
    private SliderInputView parent = null;
    private String valueStr;
    private Rectangle rect = null;

    public SliderInputUI() {
	super();
    }
     public SliderInputUI(JSlider b, SliderInputView par) {
	 this(b);
	 parent = par;
     }

     public SliderInputUI(JSlider b) {
	 comp = b;
	 valueStr = new String().valueOf(comp.getMaximum()/2);

	 comp.addChangeListener(new javax.swing.event.ChangeListener() {		 
		 public void stateChanged(javax.swing.event.ChangeEvent e) {
		     valueStr = new String().valueOf(((JSlider)e.getSource()).getValue());
		     if (rect != null)
			 comp.repaint(rect);
		     
		 }
	     });
	 
     }

    public void paintThumb(Graphics g) {
 	super.paintThumb(g);
	int width = comp.getSize().width;
	int height = comp.getSize().height;
	g.setColor(Color.black);
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	FontMetrics fm = g.getFontMetrics();
 	g.drawString(valueStr, width / 2 - fm.stringWidth(valueStr) / 2,
				 fm.getMaxAscent() +height/2);
	// repaint the minimum, just a small rectangle !
	if (parent != null) {
	    if ((rect == null) || parent.isResized()) {
		parent.setResized(false);
// 		System.out.println("width "+width);
		int drawWidth = comp.getMaximum();
		rect = new Rectangle(width/2-fm.stringWidth(new String().valueOf(drawWidth))/2, height/2-fm.getMaxAscent(),width,fm.getMaxAscent()*2);
	    }
	}
    }

    public String getValueStr() {
	return valueStr;
    }


} // SliderInputUI
