package mosaic.vis.output;

import java.awt.*;
import javax.swing.*;
import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.*;

public class BoolAnimatedImageView extends AnimatedImageView implements VariableChangeListener {

    //
    // Construction
    //

    public BoolAnimatedImageView() {
        this(null);
    }

    public BoolAnimatedImageView(ImageIcon[] images) {
        this(images, 1.0);
    }

    public BoolAnimatedImageView(ImageIcon[] images, double cycleTime) {
        super(images);
        setCycleTime(cycleTime);
        setImagePaintTime(INFINITY);
    }


    /** Set the time to make one cycle of image output */
    public void setCycleTime(double time) {
        cycleTime = time;
    }

    public void variableChange (VariableChangeEvent e) {
        super.variableChange(e);
        if (e.getValue() instanceof Boolean) {
            isOn = ((Boolean)e.getValue()).booleanValue();
            if (isOn) {
                setImagePaintTime(cycleTime/getNrImages());
            } else {
                setImagePaintTime(INFINITY);
            }
        } else {
            System.err.println("Error in BoolAnimatedImageView: variableChange val: " + e.getValue());
        }
        repaint();
    }

    public void propertyChange (java.beans.PropertyChangeEvent e){};
    public void addListenerVariable (Variable v){
        getSimApplication().getAnimator().addView(this);
    };
    public void removeListenerVariable (Variable v){
        getSimApplication().getAnimator().removeView(this);
    };

}
