package mosaic.vis.output;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import mosaic.sim.kernel.*;

public class ExpandSymbol extends AbstractModelComponent {



    public ExpandSymbol() {
        super();
        try  {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

   public void paintComponent(Graphics g) {
        g.setColor(getBackground());
        g.fillRect(0,0, getWidth(), getHeight());
        if (owner != null) {
            if (owner.isExpanded()) {
                g.setColor(getForeground());
                g.fillPolygon( new int[] {getWidth(), 0, getWidth()},
                               new int[] {0, getHeight()/2 , getHeight()},
                               3 );
            } else {
                g.setColor(getForeground());
                g.fillPolygon( new int[] {0, getWidth(), 0},
                               new int[] {0, getHeight()/2 ,getHeight()},
                               3 );
            }
        }
    }

    // react to mouse-clicks ---------------------------------------------------
    public void ExpandSymbol_mouseClicked(MouseEvent e) {
        if (owner.isExpanded()) {
            owner.collapse();
        } else {
            owner.expand();
        }
    }

    
    protected expandable owner;

    public void setOwner(expandable v) {
        owner = v;
    }

    public expandable getOwner() {
        return owner;
    }

    private void jbInit() throws Exception {
        this.addMouseListener(new java.awt.event.MouseAdapter() {

            public void mouseClicked(MouseEvent e) {
                ExpandSymbol_mouseClicked(e);
            }
        });
    }
}
