package mosaic.vis.output;

import java.awt.*;
import javax.swing.*;
import mosaic.sim.kernel.variable.*;
import mosaic.sim.kernel.*;

public class NumberAnimatedImageView extends AnimatedImageView implements VariableChangeListener {

    double currentValue = 0.0;
    //
    // Construction
    //

    public NumberAnimatedImageView() {
        this(null, 1.0);
    }

    public NumberAnimatedImageView(ImageIcon[] images) {
        this(images, 1.0);
    }

    public NumberAnimatedImageView(ImageIcon[] images, double cycleTime) {
        super(images);
        setCycleTime(cycleTime);
        setImagePaintTime(INFINITY);
    }


    public void variableChange (VariableChangeEvent e) {
       super.variableChange(e);
        if (e.getValue() instanceof Number) {
            currentValue = ((Number)e.getValue()).doubleValue();
            isOn = (currentValue != 0.0);
            if (isOn) {
                setImagePaintTime(cycleTime/(getNrImages()*currentValue));
            } else {
                setImagePaintTime(INFINITY);
            }
        } else {
            System.err.println("Error in BoolAnimatedImageView: variableChange val: " + e.getValue());
        }
        repaint();
    }
}
