package mosaic.vis.output;

//import mosaic.sim.kernel.AbstractModelComponent;
import javax.swing.*;
import java.awt.*;
import mosaic.vis.output.NumberView;
import java.util.Vector;

// use this registered as a VariableChangeListener to a integer Variable
// representing State of any Component, switches Image corresponding to
// the value of the state Variable
public class StateImageView extends NumberView {

    public StateImageView() {
        try  {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        setValue(new Integer(initDrawing));
    }

    private void jbInit() throws Exception {}

   // Property drawing to set backgroundimages --------------------------------

    ImageIcon[] images;

    public void setDrawingURLs(java.net.URL[] urls) {
        images = new ImageIcon[urls.length];
        for (int i = 0; i < urls.length; i++) {
            if (urls[i] == null) {
                images[i] = null;
            }
            else
                images[i] = new ImageIcon(urls[i]);
        }
    }


    // overwrite paintWithGfx to start repaint by AWT
    public synchronized void paintWithGfx (Graphics g) {
        repaint();
    }

    // to allow repaint scheduling to AWT
    public void paintComponent(Graphics g) {
        paintValue(g);
    }


    public synchronized void paintValue(Graphics g) {
        if (images != null) {
            if (getNumber() != null) { // state number defined
//                System.out.println("StateImageView :: paintValue() ");
                int index = getNumber().intValue();
                if (index < images.length) { // index is in range
                    if (images[index] != null){
                        g.drawImage(images[index].getImage(), 0,0,this);
                    }
                }
            }else{ // no state number defined
                if (images.length > 0) {
                    if (images[0] != null)
                        g.drawImage(images[0].getImage(), 0,0,this);
                }
            }
        }
    }
    
// Properties ------------------------------------------------------------------

    int initDrawing = 0;

    // Propertie to set initialValue of constant
    public void setInitDrawing(int  number) {
        initDrawing = number;
        this.setValue(new Integer(number));
        repaint();
    }

    public double getInitValue() {
        return initDrawing;
    }


}
