package mosaic.vis.output;

import mosaic.vis.general.VariableView;
import javax.swing.ImageIcon;
import java.awt.*;

public class ToggleImageView extends VariableView{

    public ToggleImageView() {
        try  {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {}

// boolean value ---------------------------------------------------------------

    /** variable to store the boolean property value */
    boolean onOff= false;
    /** Sets a new boolean value to display */
    public void setOnOff(boolean newValue) {
        onOff= newValue;
        repaint();
    }
    /** Gets the current boolean value displayed */
    public boolean getOnOff() {
        return onOff;
    }

// setValue --------------------------------------------------------------------

    /**
    * Reacts to a new property value by setting the onOff value.
    * Called by super.propertyChange.
    * @param newVal The new value object received from the property change
    */
    public void setValue (Object newVal) {
        if (newVal instanceof Boolean) {
            super.setValue(newVal);
            setOnOff (((Boolean)newVal).booleanValue());
        }
        else
            System.out.println(">> tried to send non Boolean value to " + toString());
    }


// Property drawing to set backgroundimages for On and Off state ---------------

    ImageIcon onImage;
    ImageIcon offImage;
    java.net.URL onImageURL, offImageURL;


    public void setOnImageURL(java.net.URL url)
    {   // try to get gif from URL
        onImage = new ImageIcon(url);
        if (onImage != null)
            onImageURL = url;
    }

    public java.net.URL getOnImageURL() {
        return onImageURL;
    }

    public void setOffImageURL(java.net.URL url)
    {   // try to get gif from URL
        offImage = new ImageIcon(url);
        if (offImage != null)
            offImageURL = url;
    }

    public java.net.URL getOffImageURL() {
        return offImageURL;
    }

// painting --------------------------------------------------------------------

    // overwrite paintWithGfx to start repaint by AWT
    public synchronized void paintWithGfx (Graphics g) {
        repaint();
    }

    // to allow repaint scheduling to AWT
    public void paintComponent(Graphics g) {
        paintValue(g);
    }


    // draw image if value has changed
    public synchronized void paintValue(Graphics g) {
//        System.out.println("ToggleImageView :: paintValue() ");
        if (getOnOff()) {  // show onImage
            if (onImage != null)
		        g.drawImage(onImage.getImage(), 0,0,this);
        } else {
            if (offImage != null)
		        g.drawImage(offImage.getImage(), 0,0,this);
        }
    }

}


